#include <stdio.h>
#include <stdlib.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "gd.h"

int main(void) {

  FILE *gif;
  int mmap_file;
  gdImagePtr im;
  unsigned char gifdata[9000];
  unsigned char *gifdata_mmap;

  gif = fopen("test.gif", "r");
  fread(gifdata, 1, 9000, gif);
  rewind(gif);


  if ( im = gdImageCreateFromGif(gif) ) {
    fprintf(stderr, "file open success!\n");
    gdImageDestroy(im);
  } else {
    fprintf(stderr, "file open failed!\n");
  }

  fclose(gif);

  mmap_file = open("test.gif", O_RDONLY);
  gifdata_mmap = mmap(0, 8994, PROT_READ, MAP_PRIVATE, mmap_file, 0);

  if ( im = gdImageCreateFromGifPtr(8994, (char*) &gifdata_mmap[0]) ) {
    fprintf(stderr, "mmap open success!\n");
    gdImageDestroy(im);
  } else {
    fprintf(stderr, "mmap open failed!\n");
  }

  close(mmap_file);


  if ( im = gdImageCreateFromGifPtr(8994, (char*) &gifdata[0]) ) {
    fprintf(stderr, "pointer open success!\n");
    gdImageDestroy(im);
  } else {
    fprintf(stderr, "pointer open failed!\n");
  }

  return 0;
}

